; Speelt alle noten (in een beetje normaal toonhoogtebereik) die op de
;  PSG afgespeeld worden, ook via MIDI af. (Via de Music Module.)

; Maker: ???


        ORG   0C000H

        DI
        LD    A,00010101B
        OUT   (0),A
        LD    HL,0FD9FH
        LD    DE,INT_TA
        LD    BC,05H
        LDIR
        LD    A,0C3H
        LD    (0FD9FH),A
        LD    HL,INT_RT
        LD    (0FDA0H),HL
        EI
        RET

;PSGUIT: ; Zet hook terug
;       LD    HL,INT_TA
;       LD    DE,&HFD9F
;       LD    BC,5
;       DI
;       LDIR
;       EI
;       RET

INT_RT: DI
        PUSH  AF
        EXX
        LD    BC,0E00H        ; Zet 14 PSG registers in tabel PSG_DAT
        LD    HL,PSG_DA
LP_1:   LD    A,0EH
        SUB   B
        OUT   (0A0H),A
        IN    A,(0A2H)
        LD    (HL),A
        INC   HL
        DJNZ  LP_1

        LD    HL,PSG_DA+5     ; Kijk of toonhoogte is veranderd (Carry=ja)
        LD    DE,PSG_DT+5
        LD    B,3
LP_2:   LD    A,(DE)
        CP    (HL)
        DEC   HL
        DEC   DE
        JR    NZ,NX_1
        LD    A,(DE)
        CP    (HL)
NX_1:   DEC   HL
        DEC   DE
        JR    Z,NX_2
        SCF
NX_2:   RL    C
        DJNZ  LP_2

        LD    B,3             ; SPEEL PGS-DATA OP MIDI:
        INC   HL
LP_3:   LD    E,(HL)          ; Lees toonhoogte-data
        INC   HL
        LD    D,(HL)
        INC   HL
        RR    C
        PUSH  HL
        PUSH  BC
        LD    C,B
        LD    B,0
        LD    HL,PSG_VO+4
        JR    NC,NX_6         ;  als toonhoogte niet veranderd is
        SBC   HL,BC
        LD    A,(HL)          ;  volume

NX_9:   EX    AF,AF           ; Zoek goede Tone-data
        LD    B,97
        LD    HL,TONEDA
        LD    A,D
        AND   A
        JR    NZ,LP_4
        LD    B,52            ; (als toonhoogte MSB=0, zet HL dan verder
        LD    HL,TONEDT       ;   dit maakt het zoeken een stuk korter)
LP_4:   LD    A,(HL)
        INC   HL
        CP    D
        LD    A,(HL)
        INC   HL
        JR    NZ,NX_3
        SUB   E
        JR    NC,NX_4
        CPL
NX_4:   LD    C,A
        LD    A,(HL)
        CP    D
        JR    NZ,NX_5
        INC   HL
        LD    A,(HL)
        DEC   HL
        SUB   E
        JR    NC,NX_3
        CPL
        CP    C
        CCF
NX_5:   LD    A,122
        SBC   A,B
        POP   BC

        PUSH  BC              ; Sla Tone-data op in MIDIDA
        LD    C,B
        LD    HL,MIDIDA-2
LP_5:   INC   HL
        INC   HL
        DJNZ  LP_5
        CP    (HL)            ;  nog zelfde toon: weg
        JR    Z,NX_7

        LD    B,A
        EX    AF,AF           ;  volume * 16
        RLCA
        RLCA
        RLCA
        LD    E,A

;       LD    A,&H83          ;  voor op 3 versch. MIDIkanalen
;       SUB   C
        LD    A,80H           ;  voor alles op 1 kanaal

        CALL  SNDMID          ; Zet oude toon uit; sla nieuwe toon op
        LD    A,(HL)
        LD    (HL),B
        INC   HL
        CALL  SNDMID
        LD    A,(HL)
        LD    (HL),E
        INC   HL
        CALL  SNDMID

        LD    A,93H
        SUB   C
        LD    A,90H

        CALL  SNDMID          ; Zet nieuwe toon aan
        LD    A,B
        CALL  SNDMID
        LD    A,E
        CALL  SNDMID
NX_7:   POP   BC
        POP   HL
NX_8:   DJNZ  LP_3

        LD    HL,PSG_DA       ; Oude waardes PSG-registers bewaren
        LD    DE,PSG_DT
        LD    C,0EH
        LDIR
        EXX
        POP   AF
        EI
INT_TA: DEFB  0C9H,0C9H,0C9H,0C9H,0C9H
        RET

NX_3:   DJNZ  LP_4
        JR    NX_7

NX_6:   CCF                   ; Toonhoogte niet veranderd: kijk volume na
        SBC   HL,BC
        LD    A,(HL)          ;  volume v. huidig kanaal
        LD    DE,0EH
        ADD   HL,DE
        LD    E,(HL)          ;  vorig volume
        POP   BC
        POP   HL
        AND   A
        JR    NZ,NX_8         ; (niet 0)
        CP    E
        JR    Z,NX_8          ; (zelfde gebleven)
        PUSH  HL
        PUSH  BC
        DEC   HL
        LD    (HL),A          ;  volume 0 geworden : zet PSG-toonhoogte op 1
        DEC   HL
        LD    E,01H
        LD    (HL),E
        JP    NX_9

SNDMID: PUSH  AF
LP:     IN    A,(4)
        BIT   1,A
        JR    Z,LP
        POP   AF
        OUT   (1),A
        RET
PSG_DA: DEFB  0,0,0,0,0,0,0,0 ; Tabel met 14 PSG-registers
PSG_VO: DEFB  0,0,0,0,0,0     ;
PSG_DT: DEFB  0,0,0,0,0,0,0,0,0,0,0,0,0,0
MIDIDA: DEFB  0,0,0,0,0,0
SGN_CN: DEFB  1
TONEDA: DEFB  13,93,12,156,11,231,11,60,10,155,10,2,9,115,8,235,8,107
        DEFB  7,242,7,128,7,20,6,175,6,78,5,244,5,158,5,78,5,1,4,186
        DEFB  4,118,4,54,3,249,3,192,3,138,3,87,3,39,2,250,2,207,2,167
        DEFB  2,129,2,93,2,59,2,27,1,253,1,224,1,197,1,172,1,148,1,125
        DEFB  1,104,1,83,1,64,1,46,1,29,1,13
TONEDT: DEFB  0,254,0,240,0,227,0,214,0,202,0,190,0,180,0,170,0,160
        DEFB  0,151,0,143,0,135,0,127,0,120,0,113,0,107,0,101,0,95,0,90
        DEFB  0,85,0,80,0,76,0,71,0,67,0,64,0,60,0,57,0,53,0,50,0,48
        DEFB  0,45,0,42,0,40,0,38,0,36,0,34,0,32,0,30,0,28,0,27,0,25
        DEFB  0,24,0,22,0,21,0,20,0,19,0,18,0,17,0,16,0,15,0,14,0,1,0,0
45,0,42,0,40,0,38,0,3